# Info

This is a wrapper for Ptolemy DWBA calcalation using GUI from CERN ROOT. 

The Ptolemy reference is M. H. Macfarlane and S. C. Pieper, ANL-76-11 Rev. 1, Argonne National Laboratory, 1978.

The core program (ptolemy) only works in Linux. For Mac OS, a docker container is avalible. See the __Cleopatra/install_ptolemy_mac.txt__

# Two versions

## CERN ROOT 

in the __working__ directory, run 
>./PtolemyGUI

Actually the program can run anywhere. It will copy the DWBA file to the present directory.

## Python 

in the __PyGUIQt6__ directory, run
>./PtolemyGUIPy.py

This program does not work on any where

# output:

1. DWBA.in, this is the input file for the ptolmey
2. DWBA.output, this is the output file for the ptolmey
3. DWBA.Xsec.txt, this is the angular distribution in txt format

the following will be generated by the CERn ROOT version

4. DWBA.Ex.txt, this is the excitation energy
5. DWBA.root, this is a root file contains the DWBA angular distribution in TGraph

# program structure

It reads the DWBA file, creates the DWBA.in with the InfileCreator.h, run the ptolemy, read the DWBA.out with the ExtractXsec.h, save the result in DWBA.Ex.txt and DWBA.root, and then use the PlotTGraphTObjArray.h to plot in root.

The optical potentials are stored in the __Cleopatra/potentials.h__

